/* dxf2pov.exe DXF to POV-Ray file Converter Written By Atsuro Seto */
/* (c)1999-2007 All Rights Reserved. Atsuro Seto <atsuro@cc.rim.or.jp> */
/* Version 1.0 26/FEB/99 */
/* Version 1.1 13/MAR/07 */
/* Version 1.2 23/MAR/07 */
#define _CRT_SECURE_NO_DEPRECATE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "idx2col.h"


#define BUFSIZE 256 // number of characters in the longest line + null(\0)
FILE *dxffile, *incfile, *povfile, *inifile;
char dxfname[_MAX_PATH], incname[_MAX_PATH], povname[_MAX_PATH], ininame[_MAX_PATH];
char fname[_MAX_FNAME];
char datetime[128];

char *trim( char *szSource );
void writeIncHeader(void);
void writePov(void);
void writeIni(void);

int main(int argc, char *argv[]){


	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char ext[_MAX_EXT];
	char linbuf[BUFSIZE];
	int dxf_code=-1;
	char ComeOn3D[BUFSIZE];
    char *pszEOS;

	int iWedge=-1;
	//int colIndices[BUFSIZE];////////////////////////
	int prev_color_index=-1;
	int cur_color_index=-1;
	int colorNum_0To=-1;
	int colorsNum_1To[BUFSIZE]={0};
	int linearTotals_0To=0;
	
	int layerNum_1To=-1;

	typedef struct {
		char name[BUFSIZE];
		int col;
		int cols[BUFSIZE];
	}structLAYERS;
	
	structLAYERS lyr[BUFSIZE];

	structLAYERS curLyr;
	//curLyr.name={""};

	typedef struct {
		char lname[BUFSIZE];
		int cidx;
	}structLinearLyrsCols;
	
	structLinearLyrsCols lnum_cidx[BUFSIZE];


	int bLyrTBL=-1;
	bool blLyrIn3D=false;
	bool blColInLyr=false;
	//float red, green, blue;
	//char sR[80];
	//char sG[80];
	//char sB[80];

	int i=0; 
	int j=0;
	int m=0;
	int n=0;
	int prev=-1;

	long num_polygons = 0L;
	long total_polys=0L;
	int lineCount=0;
	int totalFaces=0;
	float xcoords[4];
	float ycoords[4];
	float zcoords[4];

	float xmin=0.0;
	float xmax=0.0;
	float ymin=0.0;
	float ymax=0.0;
	float zmin=0.0;
	float zmax=0.0;
	float mirror;
	double centerx;
	double centery;
	double centerz;
	DXFColor colIndx={0,0,0};

	//for(i=0;i<=255;i++){
	//	DXFColor colIndx=index2Color(i);
	//	printf("{%.4f, %.4f, %.4f},\n",colIndx.R, colIndx.G, colIndx.B);
	//}

    printf("\ndxf2pov.exe DXF to POV-Ray file Converter Version 1.2\n");
    printf("Written By Atsuro Seto, 23/MAR/2007\n\n");
    if (argc != 2) // if dxf-name only
    {
        printf("Usage:  dxf2pov.exe *.dxf\n");
        exit(1);//opening was failed, immediately exit.
    }
    strcpy(dxfname, argv[1]);        // copy array argv[1] to array dxfname[centerx].
    if (!strchr(dxfname, '.')) strcat(dxfname, ".dxf"); // if no dot present in filename, then add ".dxf" at the end of dxfname.
    if (!(dxffile = fopen(dxfname, "r"))) // if FILE cannot open as readable.
    {
        printf("Cannot open input file %s!\n", dxfname);
        exit(1);//failed
    }
	_splitpath( dxfname, drive, dir, fname, ext);
	printf( "Origin: %s\n\n", dxfname );

///////////////////////////////////////////////////////////////////////////////////////////////
    while (!feof(dxffile))           
    {
		fgets(linbuf, BUFSIZE, dxffile); // get a line from dxffile to linbuf
		strncpy_s(ComeOn3D, _countof(ComeOn3D), linbuf, strlen(linbuf)-1);
		lineCount++;
		if (strstr(ComeOn3D, "ENTITIES"))
		{
			printf("%d> Reached \"%s\" ", lineCount, ComeOn3D);
			break;
		}
		if (strstr(ComeOn3D, "3DFACE")) break;
		if (strstr(ComeOn3D, "TABLES"))	continue;
		if (!strstr(ComeOn3D, "TABLE"))	continue;
		// A TABLE inside

		fgets(linbuf, BUFSIZE, dxffile); // expecting number 2
		sscanf(linbuf, "%d", &dxf_code);  // scan out dxf_code
		lineCount++;
		if (dxf_code != 2)continue;   
		// here division mark 2 appears.

		fgets(linbuf, BUFSIZE, dxffile); 
		strncpy_s(ComeOn3D, _countof(ComeOn3D), linbuf, strlen(linbuf)-1);
		lineCount++;
		if (!strstr(ComeOn3D, "LAYER")) continue;
		// LAYER Header

		printf("%d> Entered \"%s\" definition\n", lineCount, ComeOn3D);

		fgets(linbuf, BUFSIZE, dxffile); // Layer code
		sscanf(linbuf, "%d", &dxf_code);
		lineCount++;
		if (dxf_code!=70)
			printf("%d> Warning! Expected code 70 but %d\n\n", lineCount, dxf_code);

		fgets(linbuf, BUFSIZE, dxffile); // total number of this TABLE's LAYER entries.
		sscanf(linbuf, "%d", &layerNum_1To);//start from count 1 
		lineCount++;
		printf("%d> Pre-defined Layer Numbers 1 To %d\n", lineCount, layerNum_1To);

		for(i=0; i<layerNum_1To; i++){//if layerNum_1To==3 then i=0,1,2

			fgets(linbuf, BUFSIZE, dxffile); // get a line from dxffile to linbuf
			sscanf(linbuf, "%d", &dxf_code);  // scan out dxf_code
			lineCount++;
			if (dxf_code != 0)
			{
				printf("%d> Error!! Expected code 0 but %d\n", lineCount, dxf_code);
				fclose(dxffile);
				exit(1);
			}
			// here division mark 0 appears.

			fgets(linbuf, BUFSIZE, dxffile); // get another line from dxffile
			strcpy(ComeOn3D, linbuf); // get new line just beneath the code 0
			lineCount++;
			if (!strstr(ComeOn3D, "LAYER") )
			{
				printf("%d> Error!! Expected \"LAYER\" but %s\n", lineCount, ComeOn3D);
				fclose(dxffile);
				exit(1);
			}
			fgets(linbuf, BUFSIZE, dxffile);
			sscanf(linbuf, "%d", &dxf_code); // expecting number 2 
			lineCount++;
			if (dxf_code != 2)
				printf("%d> Warning! Expected code 2 but %d\n\n", lineCount, dxf_code);

			fgets(linbuf, BUFSIZE, dxffile); // Here should come a Layer Name!!
			lineCount++;
			//strncpy_s( lyr[i].name, _countof(lyr[i].name), linbuf, strlen(linbuf)-1);
			//strcpy(lyr[i].name, linbuf);
			pszEOS=trim(linbuf);
			strcpy(lyr[i].name, pszEOS);

			//printf("\"%s\" ",lyr[i].name);

			fgets(linbuf, BUFSIZE, dxffile); // trash code 70
			fgets(linbuf, BUFSIZE, dxffile); // trash code 64 or something
			lineCount++;
			lineCount++;

			fgets(linbuf, BUFSIZE, dxffile); 
			sscanf(linbuf, "%d", &dxf_code); // expecting 62
			lineCount++;

			if (dxf_code!=62)
			{
				printf("%d> Error!! Expected code 62 but %d\n", lineCount, dxf_code);
				fclose(dxffile);
				exit(1);
			}
			// Got code 62

			fgets(linbuf, BUFSIZE, dxffile); // Color index
			sscanf(linbuf, "%d", &lyr[i].col);
			lineCount++;
			//printf("(%d)\n",lyr[i].col);

			fgets(linbuf, BUFSIZE, dxffile); // trash code 6
			fgets(linbuf, BUFSIZE, dxffile); // trash "BlahBlahBlah"
			lineCount++;
			lineCount++;
		}
		printf("%d> Ended \"LAYER\" Cycle.\nGet down and facing Every Color through \"EOF\".\n\n", lineCount);
		break;
	}

	if(layerNum_1To<1)
	{
		layerNum_1To=0;//treat as single Layered at least.
		colorsNum_1To[0]=0;
		printf("without finding LAYER TABLE in Header Section.\n");
		printf("Let's get into 3DFACE while still looking for Layer Names and Colors\n\n");
	}
/////////////////////////////////////////////////////////////////////////////////////////
	while (!feof(dxffile))           
	{
		fgets(linbuf, BUFSIZE, dxffile); // get a line from dxffile to linbuf
		strncpy_s(ComeOn3D, _countof(ComeOn3D), linbuf, strlen(linbuf)-1);
		lineCount++;
		if (strstr(ComeOn3D, "EOF"))
		{
			//printf("layerNum_1To%d\n", layerNum_1To);
			printf("\"LayerName\" (IndexColor)\n");
			for(i=0;i<layerNum_1To;i++)
			{
				printf("\"%s\"", lyr[i].name);
				for(j=0;j<colorsNum_1To[i];j++)
					printf(" (%d)", lyr[i].cols[j]);
				printf("\n");
			}
			printf("\n%d> Reached \"%s\"\n", lineCount, ComeOn3D);
			break;
		}
		if (!strstr(ComeOn3D, "3DFACE"))	continue;
		//3DFACE inside
		totalFaces++;

		fgets(linbuf, BUFSIZE, dxffile); // ignore number 
		sscanf(linbuf, "%d", &dxf_code);
		lineCount++;
		if (dxf_code!=8)
			printf("%d> Warning! Expected code 8 but %d\n", lineCount, dxf_code);

		fgets(linbuf, BUFSIZE, dxffile); // layer name.
		lineCount++;
		//strncpy_s(curLyr.name, _countof(curLyr.name), linbuf, strlen(linbuf)-1);
		//strcpy(curLyr.name, linbuf);
		pszEOS=trim(linbuf);
		strcpy(curLyr.name, pszEOS);

		for(i=0;i<layerNum_1To;i++){
			if(strcmp(lyr[i].name, curLyr.name)==0)
			{
				blLyrIn3D=true;
				break;// i break out without i++. So this i equals current in the array.
			}
			blLyrIn3D=false;
		}//final i++ will reach the exact [layerNum_1To] value and out from loop
		if(!blLyrIn3D)
		{
			//[((((layerNum_1To -1)))) +1] points the empty container after the last used layer
			strcpy(lyr[i].name, curLyr.name);
			//colorsNum_1To[i]=1;
			layerNum_1To++; //Yes +1. We surely spent a container.
		}
			//printf("lyr[%d].name is \"%s\"\n", i,lyr[i].name);

		fgets(linbuf, BUFSIZE, dxffile); // Color code
		sscanf(linbuf, "%d", &dxf_code);
		lineCount++;
		if (dxf_code != 62 && dxf_code!=70) // Color code 62
		{
			printf("DXF Color Code should be 62 but %d\n%s %d)\n", dxf_code, dxfname, lineCount);
			fclose(dxffile);
			exit(1);
		}

		fgets(linbuf, BUFSIZE, dxffile); // Color index
		sscanf(linbuf, "%d", &cur_color_index);
		lineCount++;

		blColInLyr=false;
		for(j=0; j<colorsNum_1To[i]; j++){
			if(lyr[i].cols[j]==cur_color_index)
			{
				blColInLyr=true;
				break;
			}
			blColInLyr=false;
		}
		if(!blColInLyr){
			lyr[i].cols[j]=cur_color_index;
			colorsNum_1To[i]++;
		}
	}

	printf("Preliminary Layer <> Color Parsing Completed.\n\n");
/////////////////////////////////////////////////////////////////////////////////////////////////
	_makepath( incname, drive, dir, fname, ".inc");
    if (!(incfile = fopen(incname, "w"))) // if povname file exists as protected archive.
    {
        printf("Cannot create output file %s!\n", incname);
        fclose(dxffile); // release memory we used.
        exit(1);// failed
    }
	_makepath( povname, drive, dir, fname, ".pov");
    if (!(povfile = fopen(povname, "w"))) // if povname file exists as protected archive.
    {
        printf("Cannot create output file %s!\n", povname);
        fclose(dxffile); // release memory we used.
		fclose(incfile);
        exit(1);// failed
    }
	_makepath( ininame, drive, dir, fname, ".ini");
    if (!(inifile = fopen(ininame, "w"))) // if povname file exists as protected archive.
    {
        printf("Cannot create output file %s!\n", ininame);
        fclose(dxffile); // release memory we used.
		fclose(incfile);
		fclose(povfile);
        exit(1);// failed
    }

/////////////////////////////////////////////////////////////////////////////////////////////////


	writeIncHeader();
	printf("Deciphering RGB values from the DXF Indices.\n");
	printf("[linearCount] \"LayerNum\" (ColIndex) <R, G, B>\n");

///////////////////////////////////////////////////////////////////////////////////////////////// incfile BEGIN

	//Convert to Linear Array
	for(m=0; m<layerNum_1To; m++)//////////////////////!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	{
		for(n=0; n<colorsNum_1To[m]; n++)
		{
			strcpy(lnum_cidx[linearTotals_0To].lname, lyr[m].name);
			lnum_cidx[linearTotals_0To].cidx=lyr[m].cols[n];
			//External Function index2Color returns struct DXFColor R,G,B 0To1.0
			//typedef struct {
			//	double	R, G, B;
			//}DXFColor;
			//_declspec(dllexport) DXFColor index2Color(int i);
			colIndx=index2Color(lnum_cidx[linearTotals_0To].cidx);

			printf("[%d] \"%s\" (%d) <%.4f, %.4f, %.4f>\n", linearTotals_0To, lnum_cidx[linearTotals_0To].lname, lnum_cidx[linearTotals_0To].cidx, colIndx.R,colIndx.G,colIndx.B);
			fprintf(incfile, "#declare %s_dxfColor%d = texture {pigment { color rgb<%.4f, %.4f, %.4f>} finish {Cornellike}}\n", lnum_cidx[linearTotals_0To].lname, lnum_cidx[linearTotals_0To].cidx, colIndx.R,colIndx.G,colIndx.B);
			linearTotals_0To++;
		}
	}
	fprintf(incfile, "#else\n");
	fprintf(incfile, "	#declare sesami = seed(frame_number);\n");
	for(m=0; m<linearTotals_0To; m++)//////////////////////!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		fprintf(incfile, "	#declare %s_dxfColor%d = texture {pigment { color rgb VRand(sesami)} finish {Cornellike}}\n",lnum_cidx[m].lname, lnum_cidx[m].cidx);
	fprintf(incfile, "#end\n");
	fprintf(incfile, "\n");

///////////////////////////////////////////////////////////////////////////////////////////////// union BEGIN

	fprintf(incfile, "#declare %s = union {\n",fname);

	rewind(dxffile);
	char* Mama;
	Mama="\"OhMamaCanThisReallyBeTheEnd?ToBeStuckInsideOfMobileWithTheMemphisBluesAgain!\"";
	printf("\nConstructing mesh triangles...\n", Mama[0]);

	i=0;
	int mamaLength=0;
	mamaLength=(int)strlen(Mama);
	int oh=0;
	double perFaceInc=0.0;
	double accum=0.0;
	m=0; 
	prev=-1;
	lineCount=0;

    while (!feof(dxffile))           
    {
		fgets(linbuf, BUFSIZE, dxffile); // get another line from dxffile
		strcpy(ComeOn3D, linbuf); // get new line just beneath the code 0
		lineCount++;
		if (strstr(ComeOn3D, "3DFACE") )
		{
			fgets(linbuf, BUFSIZE, dxffile); // ignore number 
			lineCount++;

			fgets(linbuf, BUFSIZE, dxffile); // layer name.
			lineCount++;
			pszEOS=trim(linbuf);
			strcpy(curLyr.name, pszEOS);
			if(strcmp(lnum_cidx[m].lname, curLyr.name)!=0)continue;

			fgets(linbuf, BUFSIZE, dxffile);
			lineCount++;
			//sscanf(linbuf, "%d", &dxf_code); // 
			//if (dxf_code == 62 || dxf_code==70) // Color code 62 Preliminarily Checked

			fgets(linbuf, BUFSIZE, dxffile); // Color number
			sscanf(linbuf, "%d", &cur_color_index);
			lineCount++;
			if(cur_color_index!=lnum_cidx[m].cidx)continue;
			//if(cur_color_index==lyr[m].cols[0])

			//static int oh=1;
			perFaceInc+=(mamaLength/(double)totalFaces);
			double k=perFaceInc-accum;
			if(k>=1)
			{
				for(i=0; i<(int)k; i++){
					printf("%c",Mama[oh]);
					oh++;
				}
				accum=perFaceInc;
			}


			for(i=0; i<4; i++)//lower 1 digit increasing 0to3 for 4vertices
			{
				for(j=10; j<=30; j+=10)//upper digit 10to30 for xyz 3 coords
				{
					fgets(linbuf, BUFSIZE, dxffile);
					lineCount++;
					sscanf(linbuf, "%d", &dxf_code);//ignore

					fgets(linbuf, BUFSIZE, dxffile); // get a line from dxffile to linbuf
					lineCount++;
					switch(j){
					case 10:
						sscanf(linbuf, "%f", &(xcoords[i]));
						xmin=(xmin>xcoords[i])?xcoords[i]:xmin;
						xmax=(xmax<xcoords[i])?xcoords[i]:xmax;
						break;
					case 20:
						sscanf(linbuf, "%f", &(ycoords[i]));
						ymin=(ymin>ycoords[i])?ycoords[i]:ymin;
						ymax=(ymax<ycoords[i])?ycoords[i]:ymax;
						break;
					case 30:
						sscanf(linbuf, "%f", &(zcoords[i]));
						zmin=(zmin>zcoords[i])?zcoords[i]:zmin;
						zmax=(zmax<zcoords[i])?zcoords[i]:zmax;
						break;
					default:
					 	printf("Failed with code: %d\n%s %d)\n", dxf_code, dxfname, lineCount);
						fprintf(incfile, "}// Failed with code: %d\n%s %d)\n", dxf_code, dxfname, lineCount);
						fclose(dxffile);
						fclose(incfile);
						exit(1);
						break;
					}
				}
			}

			if(prev!=m){
				prev=m;// prev got dirty. Let's start a new group for the linear count m
				fprintf(incfile, "\tmesh { // %s_dxfColor%dmesh\n", lnum_cidx[m].lname, lnum_cidx[m].cidx);
			}

			fprintf(incfile, "\t\ttriangle {\n");
			fprintf(incfile, "\t\t\t<%f, %f, %f>,\n", -xcoords[0], zcoords[0], -ycoords[0]);
			fprintf(incfile, "\t\t\t<%f, %f, %f>,\n", -xcoords[1], zcoords[1], -ycoords[1]);
			fprintf(incfile, "\t\t\t<%f, %f, %f>\n\t\t}\n", -xcoords[2], zcoords[2], -ycoords[2]);
			num_polygons++;  // 1st tri in a pair of tri
			if (xcoords[2]!=xcoords[3]||ycoords[2]!=ycoords[3]||zcoords[2]!=zcoords[3])
			{
				fprintf(incfile, "\t\ttriangle {\n");
				fprintf(incfile, "\t\t\t<%f, %f, %f>,\n", -xcoords[2], zcoords[2], -ycoords[2]);
				fprintf(incfile, "\t\t\t<%f, %f, %f>,\n", -xcoords[3], zcoords[3], -ycoords[3]);
				fprintf(incfile, "\t\t\t<%f, %f, %f>\n\t\t}\n", -xcoords[0], zcoords[0], -ycoords[0]);
				num_polygons++;  // 2nd tri in the pair of tri
			}
		}//A 3DFACE END

		if (!feof(dxffile)&& !strstr(linbuf, "EOF"))continue;

		//printf("[%d] \"%s\" (%d)\n", m, lnum_cidx[m].lname, lnum_cidx[m].cidx); 
		fprintf(incfile, "\ttexture{%s_dxfColor%d}\n\t}\n", lnum_cidx[m].lname, lnum_cidx[m].cidx);
		total_polys = total_polys+num_polygons; 
		m++;

		//if(m>=layerNum_1To)
		//if(m<layerNum_1To)
		if(m<linearTotals_0To)
		{
			num_polygons=0;	
			rewind(dxffile);
			lineCount=0;
			continue;
		}


		fprintf(incfile, "}\n");/////////////////////////////////// union END
		fprintf(incfile, "// %s.inc END ///////////////////////////////////////////////////////////////\n", fname);

		mirror=-xmax; xmax = -xmin; xmin= mirror;
		mirror=-ymax; ymax = zmax; zmax=-ymin; ymin=zmin; zmin=mirror;
		centerx=xmax-fabs(xmax-xmin)/2;
		centery=ymax-fabs(ymax-ymin)/2;
		centerz=zmax-fabs(zmax-zmin)/2;
		//fac=(centerx+centery+centerz)/3;

		fprintf(incfile, "// min: <%f, %f, %f>, max: <%f, %f, %f>\n", xmin, ymin, zmin, xmax, ymax, zmax);
		fprintf(incfile, "// center: <%f, %f, %f>\n", centerx, centery, centerz);
	    fprintf(incfile, "// %d lines of DXF parsed. Converted %d polygons.\n",lineCount, total_polys);
		fprintf(incfile, "// dxf2pov Conversion Completed.\n");

		if(oh<mamaLength)
			for(i=0; i<=mamaLength-oh; i++)
			{
				printf("%c",Mama[oh]);
				oh++;
			}
		if(oh!=mamaLength) printf("\n\noh %d <> mamaLength %d\n", oh, mamaLength);

		printf("\n\nCalculating Bounding Box.\n");
		printf("min <%f, %f, %f>\nmax <%f, %f, %f>\n", xmin, ymin, zmin, xmax, ymax, zmax);
		printf("center <%f, %f, %f>\n", centerx, centery, centerz);
	    printf("\n%d Lines of DXF parsed.\n", lineCount);
		printf("%d Counts of 3DFACE division found.\n",totalFaces);
		printf("%d Polygons Converted.\n\n", total_polys);
		printf("dxf2pov Conversion Completed:\n\n");
////////////////////////////////////////////////////////////////////// incfile END

		printf( "Output1: %s\n", incname);
		writePov();
		printf( "Output2: %s\n", povname);
		writeIni();
		printf( "Output3: %s\n", ininame);

////////////////////////////////////////povfile END inifile END
		fclose(dxffile);
		fclose(incfile);
		fclose(povfile);
		fclose(inifile);
		exit(0);

	}//while(!feof(inifile)) END 
	exit(1);
}

char *trim( char *szSource )
{
    char *pszEOS;

		// Set pointer to end of string to point to the character just before the 0 at the end of the string.
		pszEOS = szSource + strlen( szSource ) - 1;
		while( pszEOS >= szSource && *pszEOS == '\n' )
			*pszEOS-- = '\0';
		pszEOS = szSource + strlen( szSource ) - 1;
		while( pszEOS >= szSource && *pszEOS == ' ' )
			*pszEOS-- = '\0';
		pszEOS = szSource;
		while( *pszEOS == ' ' && *pszEOS != '\0' )
			*pszEOS++;

    return pszEOS;
}

void writeIncHeader()
{
	fprintf(incfile, "// %s.inc file for POV-Ray ver. 3.6-3.7\n", fname);
    _strdate( datetime );
	fprintf(incfile, "// Converted on: %s ", datetime);
    _strtime( datetime );
	fprintf(incfile, "%s\n", datetime);
	fprintf(incfile, "// From: %s\n", dxfname);
	fprintf(incfile, "//   To: %s\n\n", incname);
	fprintf(incfile, "// Converted with dxf2pov.exe ver. 1.2 written by Atsuro Seto <atsuro@cc.rim.or.jp>\n");
	fprintf(incfile, "// (C) 1999-2007 Atsuro Seto. All Rights Reserved. http://www.cc.rim.or.jp/~atsuro/\n\n");
	fprintf(incfile, "// %s.inc BEGIN ///////////////////////////////////////////////////////////////\n\n", fname);

	fprintf(incfile, "#include \"colors.inc\"\n");
	fprintf(incfile, "#macro VRand(RS) < rand(RS), rand(RS), rand(RS)> #end\n\n");

	fprintf(incfile, "#declare Cornellike= finish { diffuse 0.75 ambient 0 }\n");
	fprintf(incfile, "#if (frame_number<=1)\n");
	return;
}

void writePov()
{
	fprintf(povfile, "// %s.pov file for POV-Ray ver. 3.6-3.7\n", fname);
	_strdate( datetime );
	fprintf(povfile, "// Converted on: %s ", datetime);
	_strtime( datetime );
	fprintf(povfile, "%s\n", datetime);
	fprintf(povfile, "// From: %s\n", dxfname);
	fprintf(povfile, "//   To: %s\n", povname);
	fprintf(povfile, "//  For: %s\n\n", incname);
	fprintf(povfile, "// Converted with dxf2pov.exe ver. 1.2 written by Atsuro Seto <atsuro@cc.rim.or.jp>\n");
	fprintf(povfile, "// (C) 1999-2007 Atsuro Seto. All Rights Reserved. http://www.cc.rim.or.jp/~atsuro/\n\n");
	fprintf(povfile, "// %s.pov BEGIN ///////////////////////////////////////////////////////////////\n\n", fname);

	fprintf(povfile, "#include \"colors.inc\"\n");
	fprintf(povfile, "#include \"math.inc\"\n");
	fprintf(povfile, "#include \"transforms.inc\"\n\n");

	fprintf(povfile, "#include \"%s.inc\"\n",fname),
	fprintf(povfile, "#declare incObj=%s;\n\n",fname);

	fprintf(povfile, "#declare xtent=max_extent(incObj)-min_extent(incObj);\n");
	fprintf(povfile, "#declare xtent_max=max(xtent.x, xtent.y, xtent.z);//minimum cubic root for wrapping the object\n");
	fprintf(povfile, "#declare LR=52;//Cornell's boxy room cubic root\n");
	fprintf(povfile, "#declare L=LR/2;\n");
	fprintf(povfile, "#declare eyey=36;//Your eye's height\n\n");
	//////////////////////////////////////////
	fprintf(povfile, "#declare Occupancy=(xtent.x*xtent.y*xtent.z)/pow(xtent_max,3);//Approx occupancy of incObj in a minimum cube, in any cube!\n");
	fprintf(povfile, "#declare scaleFac=(-eyey*Occupancy+LR)/xtent_max;//Scale the incObj to place it in the enough room.\n\n");
	//////////////////////////////////////////
	fprintf(povfile, "#ifndef (focy)\n");
	fprintf(povfile, "	#declare focy=L;\n");
	fprintf(povfile, "#end\n\n");

	fprintf(povfile, "#ifndef (zoomer)\n");
	fprintf(povfile, "	#declare zoomer=60;\n");
	fprintf(povfile, "#end\n\n");

	fprintf(povfile, "#declare cam_loc=<0, eyey, 80.0>;\n");
	fprintf(povfile, "#declare clook_at= <0, focy, 0 >;\n\n");

	fprintf(povfile, "#ifndef (_kla_rtr)\n");
	fprintf(povfile, "	#declare _kla_rtr=0;\n");
	fprintf(povfile, "#end\n\n");

	fprintf(povfile, "global_settings{\n");
	fprintf(povfile, "  assumed_gamma 1.0\n");
	fprintf(povfile, "  radiosity{\n");
	fprintf(povfile, "    //...................Some slow Mantras were commented out here.\n");
	fprintf(povfile, "    //pretrace_start 0.04\n");
	fprintf(povfile, "    //pretrace_end 0.01\n");
	fprintf(povfile, "    count 1           //count 200\n");
	fprintf(povfile, "    recursion_limit 2 //recursion_limit 3\n");
	fprintf(povfile, "    nearest_count 1   //nearest_count 10\n");
	fprintf(povfile, "    error_bound .4    //error_bound 0.5\n");
	fprintf(povfile, "  }\n");
	fprintf(povfile, "}\n\n");

	fprintf(povfile, "#if(_kla_rtr)\n");
	fprintf(povfile, "#declare ck = 0.0;\n");
	fprintf(povfile, "	#while (ck < 2.0)\n");
	fprintf(povfile, "		camera {\n");
	fprintf(povfile, "			location  cam_loc\n");
	fprintf(povfile, "			look_at clook_at\n");
	fprintf(povfile, "			rotate y*360*ck\n");
	fprintf(povfile, "  			angle zoomer\n");
	fprintf(povfile, "		}\n");
	fprintf(povfile, "		#declare ck = ck + 0.02;\n");
	fprintf(povfile, "	#end\n");
	fprintf(povfile, "#else\n");
	fprintf(povfile, "	camera\n");
	fprintf(povfile, "	{\n");
	fprintf(povfile, "		location cam_loc\n"); 
	fprintf(povfile, "		look_at clook_at\n");
	fprintf(povfile, "		angle zoomer\n");
	fprintf(povfile, "	}\n");
	fprintf(povfile, "#end\n\n");

	fprintf(povfile, "#declare N=3;       // Divisions per side\n");
	fprintf(povfile, "#declare DX=13/N;   // Dimensions of sub patches\n");
	fprintf(povfile, "#declare DZ=10.5/N;\n");
	fprintf(povfile, "#declare lit_area_spot=light_source\n");
	fprintf(povfile, "{\n");
	fprintf(povfile, "	<0,LR-1,0>\n");
	fprintf(povfile, "	color <1,0.67,0.21>*7\n");
	fprintf(povfile, "	area_light\n");
	fprintf(povfile, "	    DX*x, DZ*z, 4, 4\n");
	fprintf(povfile, "	    jitter\n"); 
	fprintf(povfile, "	    adaptive 0\n");
	fprintf(povfile, "	spotlight\n");
	fprintf(povfile, "	    radius -90\n");
	fprintf(povfile, "	    falloff 90\n");
	fprintf(povfile, "	    tightness 1\n");
	fprintf(povfile, "	    point_at <0,0,0>\n");
	fprintf(povfile, "	fade_power 2\n");
	fprintf(povfile, "	fade_distance  (DX+DZ)/2\n");
	fprintf(povfile, "}\n\n");

	fprintf(povfile, "#declare txSeeThru =\n");
	fprintf(povfile, "texture {\n");
	fprintf(povfile, "	pigment {\n");
	fprintf(povfile, "		checker pigment{Clear*.8},pigment{Clear}\n");
	fprintf(povfile, "		scale 5\n");
	fprintf(povfile, "	}\n");
	fprintf(povfile, "}\n\n");
	fprintf(povfile, "union{\n");
	fprintf(povfile, "	#declare i=0;\n");
	fprintf(povfile, "	#while (i<N)\n");
	fprintf(povfile, "	  #declare j=0;\n");
	fprintf(povfile, "	  #while (j<N)\n");
	fprintf(povfile, "	     light_source{\n");
	fprintf(povfile, "		     lit_area_spot\n");
	fprintf(povfile, "		     translate<i*DX-(13-DX)/2, 0, j*DZ-(10.5-DZ)/2>\n");
	fprintf(povfile, "	     }\n");
	fprintf(povfile, "	  #declare j=j+1;\n");
	fprintf(povfile, "	  #end\n");
	fprintf(povfile, "	#declare i=i+1;\n");
	fprintf(povfile, "	#end\n\n");
	fprintf(povfile, "	box{\n");
	fprintf(povfile, "	  <-6,51.87,-6><6,51.88,6>\n");
	fprintf(povfile, "	  no_shadow\n");
	fprintf(povfile, "	  pigment{White}\n");
	fprintf(povfile, "	  finish{ambient 0.78 diffuse 0}\n");
	fprintf(povfile, "	}\n");
	fprintf(povfile, "	mesh{\n");
	fprintf(povfile, "		// Floor\n");
	fprintf(povfile, "		triangle{<L, 0, L>,<-L, 0, L>,<-L, 0, -L>}\n");
	fprintf(povfile, "		triangle{<L, 0, L>,<-L, 0, -L>,<L, 0, -L>}\n");
	fprintf(povfile, "		// Ceiling\n");
	fprintf(povfile, "		triangle{<L, LR, L>,<-L, LR, -L>,<-L, LR, L>}\n");
	fprintf(povfile, "		triangle{<L, LR, L>,<L, LR, -L>,<-L, LR, -L>}\n");
	fprintf(povfile, "		// Back wall z=-L\n");
	fprintf(povfile, "		triangle{<L, LR, -L>,<L, 0, -L>,<-L, LR, -L>}\n");
	fprintf(povfile, "		triangle{<-L, LR, -L>,<L, 0, -L>,<-L, 0, -L>}\n");
	fprintf(povfile, "		pigment{White}\n");
	fprintf(povfile, "		finish{Cornellike}\n");
	fprintf(povfile, "		interior_texture {pigment {Clear}}\n");
	fprintf(povfile, "	}\n");
	fprintf(povfile, "	mesh{\n");
	fprintf(povfile, "		// Front wall z=L\n");
	fprintf(povfile, "		triangle{<L, LR, L>,<-L, LR, L>,<L, 0, L>}\n");
	fprintf(povfile, "		triangle{<-L, LR, L>,<-L, 0, L>,<L, 0, L>}\n");
	fprintf(povfile, "		pigment{Blue}\n");
	fprintf(povfile, "		finish{ambient .6 diffuse 0 reflection .5 }\n");
	fprintf(povfile, "		interior_texture {pigment {Clear}}\n");
	fprintf(povfile, "	}\n");
	fprintf(povfile, "	mesh{\n");
	fprintf(povfile, "		// Right wall\n");
	fprintf(povfile, "		triangle{<-L, LR, -L>,<-L, 0, -L>,<-L, LR, L>}\n");
	fprintf(povfile, "		triangle{<-L, LR, L>,<-L, 0, -L>,<-L, 0, L>}\n");
	fprintf(povfile, "		pigment{rgb<0.025,0.236,0.025>}\n");
	fprintf(povfile, "		finish{Cornellike}\n");
	fprintf(povfile, "		interior_texture {txSeeThru}\n");
	fprintf(povfile, "	}\n");
	fprintf(povfile, "	mesh{\n");
	fprintf(povfile, "		// Left wall\n");
	fprintf(povfile, "		triangle{<L, LR, -L>,<L, LR, L>,<L, 0, -L>}\n");
	fprintf(povfile, "		triangle{<L, LR, L>,<L, 0, L>,<L, 0, -L>}\n");
	fprintf(povfile, "		pigment{rgb<0.57,0.025,0.025>}\n");
	fprintf(povfile, "		finish{Cornellike}\n");
	fprintf(povfile, "		interior_texture {txSeeThru}\n");
	fprintf(povfile, "	}\n");
	fprintf(povfile, "	object{\n");
	fprintf(povfile, "		incObj\n");
	fprintf(povfile, "		Center_Trans(incObj,x+z)\n");
	fprintf(povfile, "		Align_Trans(incObj,-y, 0)\n");
	fprintf(povfile, "		scale scaleFac\n");
	fprintf(povfile, "		#if(xtent.y*scaleFac<eyey)//elevate incObj if so flat\n");
	fprintf(povfile, "			translate <0, L-xtent.y*scaleFac/2, 0>\n");
	fprintf(povfile, "		#end\n");
	fprintf(povfile, "	}\n");
	fprintf(povfile, "	#if (_kla_rtr=0)\n");
	fprintf(povfile, "		rotate <0, clock*360.0, 0>\n");
	fprintf(povfile, "	#end\n");
	fprintf(povfile, "}\n");
	fprintf(povfile, "// %s.pov END ///////////////////////////////////////////////////////////////\n", fname);
	return;
}

void writeIni()
{
	fprintf(inifile, "; %s.ini file for POV-Ray ver. 3.6-3.7\n", fname);
	_strdate( datetime );
	fprintf(inifile, "; Converted on: %s ", datetime);
	_strtime( datetime );
	fprintf(inifile, "%s\n", datetime);
	fprintf(inifile, "; From: %s\n", dxfname);
	fprintf(inifile, "; For Rendering: %s.pov with %s.inc\n", fname, fname);
	fprintf(inifile, "; Converted with dxf2pov.exe ver. 1.2 written by Atsuro Seto <atsuro@cc.rim.or.jp>\n");
	fprintf(inifile, "; (C) 1999-2007 Atsuro Seto. All Rights Reserved. http://www.cc.rim.or.jp/~atsuro/\n");
	fprintf(inifile, "; %s.ini BEGIN\n\n", fname);
	fprintf(inifile, "Input_File_Name=%s.pov\n",fname);
	fprintf(inifile, "\n");
	fprintf(inifile, "[320x240, Distant]\n");
	fprintf(inifile, "Width=320\n");
	fprintf(inifile, "Height=240\n");
	fprintf(inifile, "Antialias=Off\n");
	fprintf(inifile, "Clock=.96\n");
	fprintf(inifile, "\n");
	fprintf(inifile, "[320x240, Shoulder]\n");
	fprintf(inifile, "declare=focy=32;\n");
	fprintf(inifile, "declare=zoomer=30;\n");
	fprintf(inifile, "Width=320\n");
	fprintf(inifile, "Height=240\n");
	fprintf(inifile, "Antialias=Off\n");
	fprintf(inifile, "Clock=.02\n");
	fprintf(inifile, "\n");
	fprintf(inifile, "[320x240, Navel]\n");
	fprintf(inifile, "declare=focy=26;\n");
	fprintf(inifile, "declare=zoomer=18;\n");
	fprintf(inifile, "Width=320\n");
	fprintf(inifile, "Height=240\n");
	fprintf(inifile, "Antialias=Off\n");
	fprintf(inifile, "Clock=.2\n");
	fprintf(inifile, "\n");
	fprintf(inifile, "[240x180, ClockAnim]\n");
	fprintf(inifile, "Width=240\n");
	fprintf(inifile, "Height=180\n");
	fprintf(inifile, "Antialias=false\n");
	fprintf(inifile, "Initial_Frame=1\n");
	fprintf(inifile, "Final_Frame=12\n");
	fprintf(inifile, "Initial_Clock=0\n");
	fprintf(inifile, "Final_Clock=1\n");
	fprintf(inifile, "\n");
	fprintf(inifile, "[ClocklessAnim(ver3.7above only)]\n");
	fprintf(inifile, "declare=_kla_rtr=1;\n");
	fprintf(inifile, "Clockless_Animation=true;ver3.7above Only;\n");
	fprintf(inifile, "Real_Time_Raytracing=true;ver3.7above Only;\n");
	fprintf(inifile, "declare=Bounding_Method=2;ver3.7above Only;\n");
	fprintf(inifile, "Width=240\n");
	fprintf(inifile, "Height=180\n");
	fprintf(inifile, "Antialias=false\n\n");
	fprintf(inifile, "; %s.ini END ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;\n", fname);
	return;
}